;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Attack Of The Mighty Aliens From Outer Space		     ;	
;by Maciej Kozlowski					     ;
;matzieq@poczta.onet.pl					     ;
;please, don't laugh at this...				     ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



	processor 6502
	include vcs.h

	org $F800
	SEG.U VARS
	ORG $80	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;VARIABLES & CONSTANTS	      ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

fineAdjustTable = fineAdjustBegin - %11110001 
Ship_Y = #6

;;;;;;;;;;; VARIABLES


Ufo_Y 				ds 1
Player_Missile_Y 		ds 1
Ufo_Missile_Y 			ds 1
Actual_Ufo_Missile_Y		ds 1

Ship_X 				ds 1	;used in moving the ship to make sure it doesn't leave the
					;screen

Ufo_X 				ds 1	;variable used to position the ufo


Ufo_HP 				ds 1	;ufo's 'hit points' 




Lives 				ds 1		;number of remaining lives 
Score_Low 			ds 1		;two bytes of score in BCD - from 0 to 9999
Score_High 			ds 1
Score_Temp			ds 1

Digits_Addr			ds 2
Digits_Correct_Addr		ds 2

Digit0_Buffer			ds 1
Digit1_Buffer			ds 1
Lives_Buffer			ds 1
;Digit3_Buffer			ds 1

Digit0_Address			ds 2
Digit1_Address			ds 2
Digit2_Address			ds 2
Digit3_Address			ds 2

Lives_Address			ds 2



Ufo_Frame_Offset 		ds 1		;this is used for displaying particular frame of the
						;ufo

Ufo_Move_Frequency 		ds 1		;this holds actual difficulty level
Ufo_Moves 			ds 1		;and this checks if the ufo should move
Ufo_Dir 			ds 1		;ufo direction

Ufo_Speed			ds 1 		;this is the ufo's horizontal speed

Ufo_Descending_Frequency	ds 1		;descending speed

Ufo_Descending_Counter		ds 1		;and it's counter

Game_On 			ds 1	

Ufo_Sprite_Ad 			ds 2		;used to hold a pointer to appropiate ufo table

Col_Temp 			ds 1		;used to store color of Ufo sprite line

Life_Loss 			ds 1

Extra_Life			ds 1

FireNoiseOn			ds 1

WhichSound			ds 1

BKG_Noise			ds 1

	SEG 
	org $F800


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;THE BEGINNING OF ALL THIS......;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Start
	SEI
	CLD
	LDX #$FF
	TXS
	
	LDA #0
Clear
	STA 0,X
	DEX
	BNE Clear

	JSR Prepare_Vars

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
;HERE WE START WITH THE GAME FRAME ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Frame
	LDA #2					;VSYNC
	STA VSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	
	LDA #43					;set the timer so that we know, 
						;when the VBLANK ends
	STA TIM64T
	LDA #0
	STA VSYNC
	
	JSR Check_Game_Switches			;do I have to say what it does?
	JSR Joy_Handling			;subroutine that checks if player moves the 
						;joystick
	JSR Move_Objects			;subroutine that moves all game objects, 
						;checks collisions etc.

Wait						;wait for VBLANK end
	LDA INTIM
	BNE Wait




	JSR Draw_Ufo				;these routines draw all the screen
	JSR Draw_Ship		
	JSR Draw_Score
	
	LDA #2
	STA WSYNC
	STA VBLANK
	LDA #35					;set the timer so that we know, when the VBLANK ends
	STA TIM64T
	JSR Calculate_Score
	JSR Sound_Routine
	

WaitOverscan					;wait for Overscan end
	LDA INTIM
	BNE WaitOverscan
	STA WSYNC
	JMP Frame				;and here we go again!

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; THE MIGHTY SUBROUTINES FROM OUTER SPACE BEGIN HERE!  ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Prepare_Vars
	LDA #8
	STA Ufo_HP				; you need to hit the ufo 8 times before it's destroyed

	LDA #2					; traditionally, three lives at the beginning
	STA Lives

	LDA #70
	STA Ufo_Frame_Offset			;we gotta know which frame of ufo to display
	LDA #38
	STA COLUP1

	LDA #8
	STA COLUPF	

	LDA #10
	STA COLUP0

	LDA #170
	STA Ufo_Y
	LDA #80
	STA Ufo_Descending_Frequency
	STA Ufo_Descending_Counter

	LDA #60
	STA Ufo_X

	LDA #7
	STA NUSIZ1

	LDA #5
	STA Ufo_Move_Frequency

	LDA #1
	STA Ufo_Speed

	LDA #0
	STA Score_High
	STA Score_Low

	LDA #20
	STA FireNoiseOn		;it must be initialised with something

	LDA #<Digits
	STA Digits_Addr
	LDA #>Digits
	STA Digits_Addr+1
	LDA #<DigitsCorrect
	STA Digits_Correct_Addr
	LDA #>DigitsCorrect
	STA Digits_Correct_Addr+1
	RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;


Check_Game_Switches
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;




Joy_Handling
	LDX #0					;ok, so now we'll handle the joystick 
	
	LDA #%01000000 				;Left
	BIT SWCHA
	BNE NoLeft
	
	LDY Ship_X				;check, if ship is not too far on the left

	BEQ NoLeft				;if so, dont move it
	
	
	LDX #$20	
	DEC Ship_X
	DEC Ship_X
NoLeft

	LDA #%10000000 				;Right
	BIT SWCHA
	BNE NoRight
	
	LDY Ship_X				;check, if ship is not too far on the right
	CPY #140
	BEQ NoRight				;if so, dont move it

	LDX #$E0
	INC Ship_X
	INC Ship_X
NoRight
	
	STX HMP0				;if player didn't move the joystick, 0 will be written
	
	LDA INPT4				;fire
	BMI NoFire
	
	LDA Player_Missile_Y
	BNE NoFire
	LDA Ship_Y				;if missile's not already on the screen
	STA Player_Missile_Y			;set it's Y equal to ship's Y
	LDA #2
	STA RESMP0				;and set it's x position 
	LDA #0
	STA RESMP0
	LDY WhichSound
	BNE NoFire
	;STA WhichSound
	LDA #5
	STA FireNoiseOn  
NoFire
	LDA #1					;set the (very) simple playfield
	STA CTRLPF
	LDA #%00010000
	STA PF0
	LDA #0
	STA PF1
	STA PF2
	LDA #18
	STA COLUPF
	LDA #51
	STA COLUP0
	RTS



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


Move_Objects 
	
	LDA Lives
	BPL Go_On
	JMP Start
Go_On
	LDA Player_Missile_Y			;if player's missile Y is 0
	BEQ No_Move_Player_Missile		;it means, it's not on the screen
	CLC					;else, we move it up
	ADC #10					;5 pixels
	STA Player_Missile_Y			
	
No_Move_Player_Missile

	LDA Actual_Ufo_Missile_Y
	BNE Move_Ufo_Missile
	LDA Ufo_Y
	STA Ufo_Missile_Y			;set it's Y equal to ufo's Y
	CLC
	ADC #15
	STA Actual_Ufo_Missile_Y
	LDA #2
	STA RESMP1				;and set it's x position 
	LDA #0
	STA RESMP1

Move_Ufo_Missile
	DEC Ufo_Missile_Y
	DEC Actual_Ufo_Missile_Y
	

	LDA Ufo_Moves				;load ufo move counter
	BNE No_Move_Ufo				;if it's 0 
	LDA Ufo_X
	SEC
	SBC Ufo_Speed
	
	LDY Ufo_Dir				;in the direction, that lies
	BEQ Not_Right				;in Ufo_Dir
	CLC
	ADC Ufo_Speed
	ADC Ufo_Speed

	
Not_Right
	STA Ufo_X				;we should move the ufo
	LDA Ufo_Move_Frequency			;then, prepare to countdown again
	BEQ No_Change
	STA Ufo_Moves

No_Move_Ufo
	DEC Ufo_Moves				;countdown to ufo move

No_Change

	LDA Ufo_X				;if the ufo's on the left edge of the screen
	CMP #6
	BCS Not_Too_Low		
	CLC		
	LDA Ufo_X				;we change it's direction
	ADC Ufo_Speed
	STA Ufo_X
	INC Ufo_Dir

Not_Too_Low
	LDA Ufo_X				;the same for the right edge
	CMP #130

	BMI Not_Too_High

Too_High
	SEC
	LDA Ufo_X
	SBC Ufo_Speed
	STA Ufo_X
	DEC Ufo_Dir
	

Not_Too_High



	LDA #<UfoSprite				;here we preload the address of ufo sprite
    	STA Ufo_Sprite_Ad			;table, so that damn positioning code
    	LDA #>UfoSprite				;fits into the horizontal blank
    	STA Ufo_Sprite_Ad+1 

	LDA Ufo_Sprite_Ad
	CLC
	ADC Ufo_Frame_Offset
	STA Ufo_Sprite_Ad
	LDA Ufo_Sprite_Ad+1
	ADC #0
	STA Ufo_Sprite_Ad+1

	LDA Ufo_Descending_Counter		;this part of code deals with ufo's descending
	BNE Ufo_Not_Descending			;if the counter has reached 0
	LDA Ufo_Y				;subtract 5 from ufo's y
	SEC					
	SBC #8
	STA Ufo_Y	
	LDA #8
	STA BKG_Noise			
	LDA Ufo_Descending_Frequency		;and restore the counter
	STA Ufo_Descending_Counter



Ufo_Not_Descending

	DEC Ufo_Descending_Counter		;countdown

	LDA #%10000000				;here we check if player's 'photon torpedo';)
						;hit the ufo
	BIT CXM0P
	BEQ No_Hit
	LDA #1					;signal to make noise
	STA WhichSound
	LDA #30
	STA FireNoiseOn
	LDA Score_Low				;give player 1 point
	CLC
	SED
	ADC #1
	STA Score_Low
	LDA Score_High
	ADC #0
	STA Score_High
	CLD
	INC Extra_Life
	DEC Ufo_HP				;if it did, decrease ufo's hitpoints
	BNE Hit_Ufo				;and if they reach 0
	LDA #80					;restore ufo
	STA Ufo_Frame_Offset
	LDA #8				
	STA Ufo_HP
	LDA #170				;bring it back to the top of the screen
	STA Ufo_Y
	LDA Ufo_Descending_Frequency
	CMP #10					;then check if the descending frequency dropped
	BNE Decrease_Frequency			;to 10. If not, jump and decrease it
		
	LDA #80					;if it did, restore it
	STA Ufo_Descending_Frequency
	STA Ufo_Descending_Counter
	LDA Ufo_Move_Frequency			;but decrease ufo's horizontal movement delay
	BNE Faster
	LDA #5
	STA Ufo_Move_Frequency			;or if it's already pushed to it's limits,
	INC Ufo_Speed				;increase ufo's speed
	LDA Ufo_Speed
	CMP #4
	BNE Faster				;but not to infinity!
	LDA #3
	STA Ufo_Speed

Faster
	DEC Ufo_Move_Frequency
	JMP Nothing

Decrease_Frequency
	SEC
	SBC #10
	STA Ufo_Descending_Frequency
	


Nothing

Hit_Ufo
	LDA Ufo_Frame_Offset			;set the proper ufo's frame to display
	SEC
	SBC #10
	STA Ufo_Frame_Offset
	LDA #0
	STA Player_Missile_Y
	;STA CXCLR
No_Hit
	LDA #%10000000			;if ufo hits, player loses a life
	BIT CXM1P			
	BEQ NoLifeLossFromMissile	
	LDA #1				
	STA Life_Loss
	LDA #155			;store the duration of lifeloss sequence
	;STA Frame_Destroy_Duration
	DEC Lives
	LDA #0
	STA ENAM1
	STA Actual_Ufo_Missile_Y
NoLifeLossFromMissile
	STA CXCLR

	LDA Ufo_Y			;if ufo is too low, player loses a life
	CMP Ship_Y			
	BCS NoLifeLoss	
	LDA #1				
	STA Life_Loss
	;LDA #155			;store the duration of lifeloss sequence
	;STA Frame_Destroy_Duration
	LDA #170
	STA Ufo_Y
	DEC Lives


NoLifeLoss

	LDA Extra_Life
	CMP #150
	BNE No_Life
	INC Lives
	LDA #0
	STA Extra_Life
No_Life
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



Draw_Ufo
	


				;okay, so here I'm positioning the UFO using the routine
	STA WSYNC		;from stella list (mentioned by Andrew Davie in his tutorial)
				
	STA VBLANK

	STA WSYNC
	SEC 
	LDA Ufo_X		
Divideby15
	SBC #15 		; Waste the necessary amount of time dividing X-pos by 15!
	BCS Divideby15 		; 06/07 - 11/16/21/26/31/36/41/46/51/56/61/66

	TAY 			; At this point the value in A is -1 to -15. In this code I use a table
				; to quickly convert that value to the fine adjust value needed.
	LDA fineAdjustTable,Y 	; 13 -> Consume 5 cycles by guaranteeing we cross a page boundary
				; In your own code you may wish to consume only 4.
	STA HMP1 		; 17 Store the fine adjustment value.


	STA RESP1
	LDX #169		;the rest of the scanlines is used to display ship and score
	STA WSYNC
	STA HMOVE

	LDA Game_On		
	BNE No_Position
	STA RESP0	
	INC Game_On

No_Position





Line				;here the actual line begins
	STA WSYNC



UFoActive			;check if the ufo is active in this line

	
	SEC			;+2 2
	TXA			;+2 4
	SBC Ufo_Y		;+3 7 hmmm.... I'm still trying to solve how does it work
	ADC #10			;+2 9 but it does!
	BCC EndOfDrawingUfo	;+2 11

	TAY			;+2 13
	LDA (Ufo_Sprite_Ad),Y	;+5 18
	STA GRP1		;+3 21 Phew! It fits into horizontal blank!

	
	STY Col_Temp		;+3 24
	
EndOfDrawingUfo	

MissileActive


	
	SEC			;+2 26
	TXA			;+2 28
	SBC Player_Missile_Y	;+3 31
	ADC #11			;+2 33
	
	ROL			;+2 35
	ROL			;+2 37
	STA ENAM0		;+3 40

	


UfoMissileActive

	SEC				;+2 42
	TXA
	SBC Ufo_Missile_Y		;+3 45
	ADC #8				;+2 47
	ROL				;+2 49
	ROL 				;+2 51
	STA ENAM1			;+2 53
SkipUfoMissileActive
	


							;do you believe? It fits into one line!
							;I don't believe
	LDA Col_Temp			;+3 56
	ADC #37				;+2 58
	STA COLUP1			;+3 61		
				
	DEX				;+2 63
	
	BNE Line			
	RTS	


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



Draw_Ship
	LDY #14
	
Ship_Line
	STA WSYNC
ShipActive				;check if the ship is active in this line
	
					;number of lines in the ship's sprite
	LDA #10				;+2 2
	STA COLUP0			;+3 5

	LDA ShipSprite-1,Y		;+4 9 choose the correct line
	STA GRP0			;+3 12 and store it in the player reg
	


EndOfDrawingShip


	LDX #0				;+2 14
	SEC				;+2 16
	TYA
	SBC Actual_Ufo_Missile_Y	;+3 21
	ADC #8				;+2 23
	BCC SkipUfoMissileActiveHere	;+2 25
	LDX #2				;+2 27

SkipUfoMissileActiveHere
	


	STX ENAM1			;+2 29		
	
	DEY
	BNE Ship_Line

	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Draw_Score
	STA WSYNC

	LDX #5					;we begin drawing score here
	LDY #0					;6 lines
	STY CTRLPF				;we use Y as a counter 
	STY PF0					;and here to 'unmirror' the playfield, clear PF0,
	STY Digit1_Buffer			;ufo's missile and digit buffers
	STY Digit0_Buffer
	STY ENAM1
	STX COLUPF
Score_Line
	STA WSYNC	

	LDA #0
	STA PF1
	STA PF2
				
	LDA (Digit2_Address),Y			;+5 5 now, fill the buffers with digit data
	AND #$0F				;+2 7 it's a simple method which I saw in combat
	STA Digit1_Buffer			;+3 10 disassembly

	LDA (Lives_Address),Y
	AND #$0F
	STA PF1

	LDA (Digit3_Address),Y			;+5 15
	AND #$F0				;+2 17
	ORA Digit1_Buffer			;+4 21
	STA PF1					;+3 24
	

	LDA (Digit0_Address),Y
	AND #$F0
	STA Digit0_Buffer

	LDA (Digit1_Address),Y
	AND #$0F
	ORA Digit0_Buffer
	STA PF2
	
	
	INY
	DEX
	BNE Score_Line
	STX PF1
	STX PF2
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Calculate_Score
	LDA Score_Low					;in the previous version I used
	AND #$0F					;a lot of ram to hold data for
	STA Score_Temp					;displaying score
	ASL						;now I think 'how could I be so
	ASL						;stupid...' anyway, here I calculate
	CLC 						;just the pointers to the digits data
	ADC Score_Temp					
	ADC Digits_Addr
	STA Digit0_Address
	LDA Digits_Addr+1
	ADC #0
	STA Digit0_Address+1	

	LDA Score_Low
	AND #$F0
	LSR
	LSR
	STA Score_Temp
	LSR
	LSR
	CLC 
	ADC Score_Temp
	ADC Digits_Addr
	STA Digit1_Address
	LDA Digits_Addr+1
	ADC #0
	STA Digit1_Address+1	

	LDA Score_High
	AND #$0F
	STA Score_Temp
	ASL
	ASL
	CLC 
	ADC Score_Temp
	ADC Digits_Correct_Addr
	STA Digit2_Address
	LDA Digits_Correct_Addr+1
	ADC #0
	STA Digit2_Address+1	

	LDA Score_High
	AND #$F0
	
	LSR
	LSR
	STA Score_Temp
	LSR
	LSR

	CLC 
	ADC Score_Temp

	ADC Digits_Correct_Addr
	STA Digit3_Address
	LDA Digits_Correct_Addr+1
	ADC #0
	STA Digit3_Address+1		

	LDA Lives
	;AND #$0F
	STA Score_Temp
	ASL
	ASL
	CLC 
	ADC Score_Temp
	ADC Digits_Correct_Addr
	STA Lives_Address
	LDA Digits_Correct_Addr+1
	ADC #0
	STA Lives_Address+1	
		
	RTS



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



Sound_Routine
	LDY FireNoiseOn		
	LDA WhichSound		;which sound we have to play?
	BNE Other
				;this section is for firing noise
				;we're checking if there's something to play
	CPY #20
	BEQ TurnOff		;if not, we turn the sound off
	
	STY AUDF0
	LDA #8
	STA AUDV0
	LDA #1			
	STA AUDC0
	INC FireNoiseOn
	JMP EndOfPlay
Other
	LDA FireNoiseOn			;this section is for explosion sound
	BEQ TurnOff
	LSR
	STA AUDV0
	LDA #15
	STA AUDC0
	ASL
	STA AUDF0
	
	DEC FireNoiseOn
	JMP EndOfPlay

TurnOff					;and here we turn the sound off, when it finishes
	;LDA #0			
	STA WhichSound
	STA AUDF0
	STA AUDV0
	LDA #20 
	STA FireNoiseOn

EndOfPlay


MakeNoise
	LDA BKG_Noise
	BNE NoSilence
	STA AUDV1
	JMP EndOfMakingNoise
	
NoSilence
	DEC BKG_Noise
	LDA #10
	STA AUDF1
	;LDA #10
	STA AUDC1
	LDA #14
	STA AUDV1

EndOfMakingNoise
	RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; HERE IS THE GAME DATA			  ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



UfoSprite

	.byte #%00000000
	.byte #%00010000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000


	.byte #%00000000
	.byte #%00011000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000


	.byte #%00000000
	.byte #%00001000
	.byte #%00011100
	.byte #%00001000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000


	.byte #%00000000
	.byte #%00011000
	.byte #%00111100
	.byte #%00111100
	.byte #%00011000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000

	.byte #%00000000
	.byte #%00001000
	.byte #%00011100
	.byte #%00111110
	.byte #%00011100
	.byte #%00001000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000

	.byte #%00000000
	.byte #%00011000
	.byte #%00111100
	.byte #%01111110
	.byte #%00111100
	.byte #%00011000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000
	.byte #%00000000


	.byte #%00000000
	.byte #%00001000
	.byte #%00011100
	.byte #%00111110
	.byte #%01111111
	.byte #%01111111
	.byte #%00111110
	.byte #%00011100
	.byte #%00000000
	.byte #%00000000


	.byte #%00000000
	.byte #%00011000
	.byte #%00111100
	.byte #%01111110
	.byte #%01111110
	.byte #%11111111
	.byte #%01111110
	.byte #%00111100
	.byte #%00011000
	.byte #%00000000

ShipSprite
	
	.byte #%00000000
	.byte #%00000000
	.byte #%01100011	
	.byte #%01110111
	.byte #%00110110
	.byte #%00111110
	.byte #%00111110
	.byte #%00010100
	.byte #%00010100
	.byte #%00011100
	.byte #%00001000
	.byte #%00001000
	.byte #%00001000
	.byte #%00001000
	.byte #%00001000

fineAdjustBegin
	.byte #%01110000 ; Left 7 
	.byte #%01100000 ; Left 6
	.byte #%01010000 ; Left 5
	.byte #%01000000 ; Left 4
	.byte #%00110000 ; Left 3
	.byte #%00100000 ; Left 2
	.byte #%00010000 ; Left 1
	.byte #%00000000 ; No movement.
	.byte #%11110000 ; Right 1
	.byte #%11100000 ; Right 2
	.byte #%11010000 ; Right 3
	.byte #%11000000 ; Right 4
	.byte #%10110000 ; Right 5
	.byte #%10100000 ; Right 6
	.byte #%10010000 ; Right 7


Digits				;these are reversed, 'cause the PF2 is reversed
				;oh, Lord....
	.byte #%11101110
	.byte #%10101010
	.byte #%10101010
	.byte #%10101010
	.byte #%11101110

	.byte #%01000100
	.byte #%01100110
	.byte #%01000100
	.byte #%01000100
	.byte #%11101110
	
	.byte #%11101110
	.byte #%10001000
	.byte #%11101110
	.byte #%00100010
	.byte #%11101110

	.byte #%11101110
	.byte #%10001000
	.byte #%11101110
	.byte #%10001000
	.byte #%11101110

	.byte #%10101010
	.byte #%10101010
	.byte #%11101110
	.byte #%10001000
	.byte #%10001000

	.byte #%11101110
	.byte #%00100010
	.byte #%11101110
	.byte #%10001000
	.byte #%11101110

	.byte #%11101110
	.byte #%00100010
	.byte #%11101110
	.byte #%10101010
	.byte #%11101110

	.byte #%11101110
	.byte #%10001000
	.byte #%10001000
	.byte #%10001000
	.byte #%10001000

	.byte #%11101110
	.byte #%10101010
	.byte #%11101110
	.byte #%10101010
	.byte #%11101110

	.byte #%11101110
	.byte #%10101010
	.byte #%11101110
	.byte #%10001000
	.byte #%11101110


DigitsCorrect

	.byte #%01110111
	.byte #%01010101
	.byte #%01010101
	.byte #%01010101
	.byte #%01110111

	.byte #%00100010
	.byte #%01100110
	.byte #%00100010
	.byte #%00100010
	.byte #%01110111
	
	.byte #%01110111
	.byte #%00010001
	.byte #%01110111
	.byte #%01000100
	.byte #%01110111

	.byte #%01110111
	.byte #%00010001
	.byte #%01110111
	.byte #%00010001
	.byte #%01110111

	.byte #%01010101
	.byte #%01010101
	.byte #%01110111
	.byte #%00010001
	.byte #%00010001

	.byte #%01110111
	.byte #%01000100
	.byte #%01110111
	.byte #%00010001
	.byte #%01110111

	.byte #%01110111
	.byte #%01000100
	.byte #%01110111
	.byte #%01010101
	.byte #%01110111

	.byte #%01110111
	.byte #%00010001
	.byte #%00010001
	.byte #%00010001
	.byte #%00010001

	.byte #%01110111
	.byte #%01010101
	.byte #%01110111
	.byte #%01010101
	.byte #%01110111

	.byte #%01110111
	.byte #%01010101
	.byte #%01110111
	.byte #%00010001
	.byte #%01110111

	org $FFFC
	.word Start
	.word Start